/*
 * 通用js库,版本V1.0
 */
//判断是否为无效值
function isEmpty(str) {
	if (str == "" || str == undefined || str == null)
		return true;
	return false;
}

//读取session存储，save:true读取后还继续保留在session;false读取后删除key
function getSessionValue(keyv, save) {
	var obj = sessionStorage.getItem(keyv);
	if (!save)
		sessionStorage.removeItem(keyv)
	return obj;
}
/*检查original有没有包含target
			包含返回true*/
function contains(original, target) {
	if (original.indexOf(target) >= 0)
		return true;
	return false;
}

//获取url中的参数
function getUrlParam(name) {
	var reg = new RegExp("(^|&)" + name + "=([^&]*)(&|$)"); //构造一个含有目标参数的正则表达式对象
	var r = window.location.search.substr(1).match(reg); //匹配目标参数
	if (r != null) return unescape(r[2]);
	return null; //返回参数值
}
//获取随机数
//t1为下限，t2为上限，t3为需要保留的小数位
function mathrom(t1, t2, t3) { 
	function isNum(n) {
		return /^\d+$/.test(n);
	}
	if (!t1 || (!isNum(t1))) {
		t1 = 0;
	}
	if (!t2 || (!isNum(t2))) {
		t2 = 1;
	}
	if (!t3 || (!isNum(t3))) {
		t3 = 0;
	}
	t3 = t3 > 15 ? 15 : t3; // 小数位不能大于15位
	var ra = Math.random() * (t2 - t1) + t1,
		du = Math.pow(10, t3);
	ra = Math.round(ra * du) / du;

	return ra;
}
/*若为android平台返回true*/
var isAndroid=(function()
{
	var res=contains(navigator.userAgent.toLowerCase(), "android");
	function fixed(){
		return res;
	}
	return fixed;
})();
/*若为ios平台返回true*/
var isIOS = (function(){
	var infor = navigator.userAgent.toLowerCase();
	var res = contains(infor, "iphone");
	if(!res)
		res = contains(infor, "ipad");
	function fix(){
		return res;
	}
	return fix;
})();
//加载本地文件
//saveName:读取到localStorage中的名字，
//jsonpath:路径
//例如：在工程目录中有个文件夹(conf),conf有abc.js。
//loadJsonFile("jsconf", "conf/abc.js");
function loadJsonFile(saveName, jsonpath) {
	$.getJSON(jsonpath, function(data) {
		var jsonBuf = localStorage.getItem(saveName);
		if (jsonBuf == null) {
			localStorage.setItem(saveName, JSON.stringify(data));
		} else {
			jsonBuf = JSON.parse(jsonBuf);
			if (jsonBuf.version != data.version)
				localStorage.setItem(saveName, JSON.stringify(data));
		}
	});
}

//得到1rem的在720宽度下的px值
function getBaseRemSize(){
	return 100 * document.body.clientWidth/720;
}

//调整配置不同APP浏览器
function initDocFontSizeForRem() {
	document.documentElement.style.fontSize = getBaseRemSize()+'px';
	// alert(document.documentElement.style.fontSize);
};



