 //定义此方法供IOS拦截处理
function callRouterNativeFunc2017(jsonStr, cbName){}
(function(win) {
	var nullfunction = 'funcnull20170719';
	win[nullfunction] = function(err, result){};
   
	//不同平台的调用方式,根据平台差异添加
	function callByDiffPlatfom(jsonStr, cbName)
	{     
		if(isAndroid())
			try{
				//alert("call android");
				win.bridge.callRouterNativeFunc2017(jsonStr, cbName);
			}catch(err){}			
      	else if(isIOS())
      	{
            //alert("call ios");
			try{
				//IOS获取webview中的js对象，要在window.onload事件后才能获取到，所以在web页面onload执行的原生方法，有可能会得不到响应，需要延迟几毫秒
				setTimeout(function(){
					callRouterNativeFunc2017(jsonStr, cbName);
				},100);
			}catch(err){}     		
      	}
      	else 
      		alert("不支持此平台");
	}
   
	var native_function = {
        /**
         *通过bridge调用app端的方法
         * @param method
         * @param params
         * @param callback
         */
		CallAppRouter: function(method, params, callback) {
	    	
			var req = {
                'method': method,
                'data': params
            };
            var cbName = nullfunction;
            
            if(callback){
	            //生成回调函数方法名称
	            cbName = 'CB_' + Date.now() + '_' + Math.ceil(Math.random() * 10);
	            //alert("request:" + JSON.stringify(req) + ",callback:" + cbName);
	            //挂载一个临时函数到window变量上，方便app回调
	            win[cbName] = function(data) {
	                //document.write("callback:" + cbName + ",data:" + data + "<br />");
	                try{
                        //alert(data);
	                	var err = {};
	                	var result = {};
	                	if (typeof(data) !== 'undefined' && data !== null) {
	                		dataObj = JSON.parse(data);
	                	}
	                	err = dataObj.err;
	                	result = dataObj.result;
	                	callback(err, result);
	                }finally{
	                	//回调成功之后删除挂载到window上的临时函数
	                	delete win[cbName];
		            }
	            };
            }
            
            callByDiffPlatfom(JSON.stringify(req), cbName);
		}
	};

    /******************定义对外方法  begin******************/
	
	/**友盟统计
	 * 入参：
	 *  catagory:分类
	 * 	label:标签
	 */
	native_function.addUMengClickStat = function(catagory, label){
		this.CallAppRouter("addUMengClickStat", JSON.parse('{"category":"' + catagory + '","label":"' + label +'"}'));	
    };
    
    /**获取APP相关信息
     * 入参：
     *  callback:回调函数
     * 返回结果：
     * 	err:{code:0,msg:""}
     * 	result: {
		    appId: "",
		    iosId: "",
		    umengId: "",
		    pkg: "",
		    appVer: "",
		    devVer: "",
		    chnl: "",
		    lang: "",
		    appshenhe: "",
		    apptabswitch: "",
		    downloadSwitch:"",  //推广下载类开关
		    policySwitch:"",    //政策资质类开关
		    warnSwitch:"",      //违规风险类开关
		    model:"",
		    os:"",
		    osVer:"",
		    param: {
		    }
		}
     *  param对象记录应用所有参数配置。
     *  
     */
    native_function.getAppInfo = function(callback){
    	this.CallAppRouter("getAppInfo",new Object(),callback);
    };
    
    /**获取设备信息
     * 入参：
     *  callback:回调函数
     * 返回结果：
     *  err:{code:0,msg:""}
     *  result:{model:"",os:"",osVer:""} 
     */
    native_function.getDeviceInfo = function(callback){
    	this.CallAppRouter("getDeviceInfo",new Object(),callback);
    };

    /**修改当前导航条标题、颜色
     * 入参
     *  navTitle:导航栏标题
     *  navColor:导航栏颜色,16进制
     */
    native_function.chgNavStyle = function(navTitle, navColor){
    	this.CallAppRouter("chgNavStyle", JSON.parse('{"navTitle":"' + navTitle +'","navColor":"' + navColor + '"}'));
    };
    
    /**打开URL，控制导航条标题、颜色
     * 入参
     * 	url:打开链接
     *  navTitle:导航栏标题
     *  navColor:导航栏颜色,16进制，不传默认系统导航栏颜色
     */
    native_function.openUrlChgNav = function(url, navTitle, navColor){
    	this.CallAppRouter("openUrlChgNav", JSON.parse('{"url":"' + url + '", "navTitle":"' + navTitle +'","navColor":"' + navColor + '"}'));
    };
    
    /**打开URL，控制右边图标显示（图标来自本地或url）和点击后打开URL，同时控制导航条标题、颜色，如果参数为空则不作处理。
     * 入参
     * 	url:打开链接
     * 	icoFilePath:图标地址，可以是本地地址，也可以是url地址
     * 	icoClickUrl:点击打开地址
     * 	navTitle:导航栏标题
     * 	navColor:导航栏颜色,16进制
     */
    native_function.openUrlWithRIcon = function(url, icoFilePath,icoClickUrl, navTitle, navColor){
    	this.CallAppRouter("openUrlWithRIcon", JSON.parse('{"url":"' + url + '", "icoFilePath":"' + icoFilePath + '","icoClickUrl":"' + icoClickUrl +'","navTitle":"' + navTitle +'","navColor":"' + navColor + '"}'));
    };
    
    /**打开URL，控制右边分享图标点击后分享URL和文本，同时控制导航条标题、颜色，如果参数为空则不作处理。
     * 入参：
     * 	url:打开链接
     * 	shareUrl:分享URL
     * 	shareText:分享文本内容
     * 	navTitle:导航栏标题
     * 	navColor:导航栏颜色,16进制
     */
    native_function.openUrlWithShareIcon = function(url,shareUrl,shareText,navTitle,navColor){
    	this.CallAppRouter("openUrlWithShareIcon", JSON.parse('{"url":"' + url + '", "shareUrl":"' + shareUrl + '","shareText":"' + shareText +'","navTitle":"' + navTitle +'","navColor":"' + navColor + '"}'));
    };
    
    /**字符串加密方法
     * 入参：
     *  encVer:加密版本号，当前是1.0
     *  str:明文字符串
     *  callback:回调函数
     * 回调返回结果：
     *  err:{code:0,msg:""}
     *  result:{str:""}
     */
    native_function.dbtEncode = function(str, callback)
    {
    	this.CallAppRouter("dbtEncode", JSON.parse('{"str":"' + str + '","dbtVer":"1.0"}'), callback);
    };
    
    /**解密方法
     * 入参：
     *  encVer:加密版本号，当前是1.0
     *  str:密文字符串
     *  callback:回调函数
     * 回调返回结果：
     *  err:{code:0,msg:""}
     *  result:{str:""}
     */
    native_function.dbtDecode = function(str, callback)
    {
    	this.CallAppRouter("dbtDecode", JSON.parse('{"str":"' + str + '","dbtVer":"1.0"}'), callback);
    };
    
    
    /**分享URL和文本。
     * 入参：
     * 	url:链接
     * 	desc:描述
     */
    native_function.shareURL = function(url, desc){
    	this.CallAppRouter("shareURL", JSON.parse('{"url":"' + url + '", "desc":"' + desc + '"}'));
    };
    
    /**请求广告
     * 入参：
     * 	callback:回调函数
     * 回调返回结果：
     *  err:{code:0,msg:""}
     *  result:{feedId:"",imageUrl:"",topTitle:"",bottomTitle:"",mark:"",smallIconUrl:""}
     * 	
     */
    native_function.requestAd = function(callback){
    	this.CallAppRouter("requestAd", new Object(), callback);
    };
    /**请求多条广告
     * 入参：
     *  callback:回调函数
     * 回调返回结果（result是一个对象数组）：
     *  err:{code:0,msg:""}
     *  result:[{feedId:"",imageUrl:"",topTitle:"",bottomTitle:"",mark:"",smallIconUrl:""},{},{}...]
     *  
     */
    native_function.requestMultiAd = function(callback,num,typeId){
        
        this.CallAppRouter("requestMultiAd", JSON.parse('{"num":"' + num + '", "typeId":"' + typeId + '"}'), callback);
    };
    /**点击广告
     * 入参：
     *  adId: 广告
     * 	
     */
    native_function.clickAd = function(adId){
    	
    	this.CallAppRouter("clickAd", JSON.parse('{"feedId":"' + adId + '"}'));
    };
    
    /**自动根据网页动态尺寸调整容器窗体的尺寸
     * 	
     */
    native_function.autoAjustWindow = function(){
    	this.CallAppRouter("autoAjustWindow", new Object());
    };
    /**点击弹出模态框
     * 入参：
     *  clickFlag: 点击事件，为1弹出模态框，为0消失，回到原界面
     *  
     */
    native_function.clickModal = function(clickFlag){
        
        this.CallAppRouter("clickModal", JSON.parse('{"clickFlag":"' + clickFlag + '"}'));
    };
    // 分享文本
    // native_function.shareText = function(data){
    //     this.CallAppRouter("shareText", JSON.parse('{"data":"' + data + '"}'));
    // };

    /******************定义对外方法 end******************/
    
    //将native_function对象挂载到window全局
    win.NativeBridge = native_function;
})(window);

