//=======年终奖计算 start===============
//计算 未产生个税
//salary:当月工资；wxyj：五险一金；sqnzj:税前年柱奖
function getNianZhongShuiHou(salary, wxyj, sqnzj) {
	//应纳税额 = 当月工资 - 五险一金
	var ynse = parseFloat(salary) - parseFloat(wxyj);
	//
	sqnzj = parseFloat(sqnzj);
	var min = Math.min.apply(null, [3500, ynse]);
	var hender = sqnzj + min - 3500;
	var pfhender = hender / 12.0;
	var arr = [
		0, 1500.01, 4500.01, 9000.01, 35000.01, 55000.01, 80000.01
	];
	var index = arr.length - 1;
	for (; index > 0; index--) {
		if (pfhender >= arr[index])
			break;
	}
	var points = [
		0.03, 0.1, 0.2, 0.25, 0.3, 0.35, 0.45
	];
	var zq = [
		0, 105, 555, 1005, 2755, 5505, 13505
	];
	var result = hender * points[index] - zq[index];
	return {
		"yinageshui": result,
		"shuiqian": sqnzj,
		"shuihou": sqnzj - result
	};
}
//反推未产生个税
//salary:当月工资；wxyj：五险一金；sqnzj:税后年柱奖
function fantuiwgs(salary, wxyj, sqnzj) {
	salary = parseFloat(salary);
	wxyj = parseFloat(wxyj);
	sqnzj = parseFloat(sqnzj);
	var z = Math.min(3500, salary - wxyj);

	var points = [0.03, 0.1, 0.2, 0.25, 0.3, 0.35, 0.45];
	var zq = [
		0, 105, 555, 1005, 2755, 5505, 13505
	];
	var result = [];
	var bufIndex = 0;
	var min = 99999999.9;
	for (var index in points) {
		var res = (-sqnzj - points[index] + zq[index]) / (points[index] - 1);
		var buf = Math.abs(getNianZhongShuiHou(salary, wxyj, res).shuihou - sqnzj);
		if (buf < min) {
			min = buf;
			bufIndex = index;
		}
		result.push(res);
	}
	var obj = {};
	obj.yinageshui = result[bufIndex] - sqnzj;
	obj.shuiqian = result[bufIndex];
	obj.shuihou = sqnzj;
	return obj;
}

//计算已产生个税
function getYcsg(salay) {
	salay = parseFloat(salay);
	var pf = salay / 12.0;
	var arr = [0, 1500.01, 4500.01, 9000.01, 35000.01, 55000.01, 80000.01];
	var arrResult = [0.03, 0.1, 0.2, 0.25, 0.3, 0.35, 0.45];
	var i = arr.length - 1;
	for (; i > 0; i--) {
		if (pf >= arr[i])
			break;
	}
	var bzd = [0, 1500.01, 4500.01, 9000.01, 35000.01, 55000.01, 80000.01];
	var bzdResult = [0, 105, 555, 1005, 2755, 5505, 13505];
	var index = bzd.length - 1;
	for (; index > 0; index--) {
		if (pf >= bzd[index])
			break;
	}
	var buf = salay * arrResult[i] - bzdResult[index];
	return {
		"yinageshui": buf,
		"shuiqian": salay,
		"shuihou": salay - buf
	};
}
//反推已产生个税
function fantuiygscs(salay) {
	var points = [0.03, 0.1, 0.2, 0.25, 0.3, 0.35, 0.45];
	var zq = [0, 105, 555, 1005, 2755, 5505, 13505];
	salay = parseFloat(salay);
	var result;
	var min = 99999999.9;
	for (var index in zq) {
		var buf = (zq[index] - salay) / (points[index] - 1);
		var res = Math.abs(getYcsg(buf).shuihou - salay);
		if (min > res) {
			min = res;
			result = buf;
		}
	}
	var obj = {};
	obj.yinageshui = result - salay;
	obj.shuiqian = result;
	obj.shuihou = salay;
	return obj;
}

//正向 计算劳务所得
function getLaowusuod(salay) {
	var laowuinfor = localStorage.getItem("LAOWUSHUILV");
	var obj = {};
	laowuinfor = JSON.parse(laowuinfor);
	salay = parseFloat(salay);
	if (salay <= parseFloat(laowuinfor.ignore)) {
		obj.yinageshui = 0;
		obj.shuiqian = salay;
		obj.shuihou = salay;
		return obj;
	} else if (salay < 4000) {
		var res = (salay - parseFloat(laowuinfor.ignore)) * 0.2;
		obj.yinageshui = res;
		obj.shuiqian = salay;
		obj.shuihou = salay - res;
		return obj;
	} else if (salay >= 4000 && salay < 20000) {
		var res = salay * 0.16;
		obj.yinageshui = res;
		obj.shuiqian = salay;
		obj.shuihou = salay - res;
		return obj;
	} else if (salay >= 20000) {
		var list = laowuinfor.table;
		for (var index in list) {
			if (eval(getFunction(list[index].range, salay))) {
				var res = salay * 0.8 * parseFloat(list[index].point) -
					parseFloat(list[index].susuan);
				obj.yinageshui = res;
				obj.shuiqian = salay;
				obj.shuihou = salay - res;
				return obj;
			}
		}
	}
	obj.yinageshui = 0;
	obj.shuiqian = 0;
	obj.shuihou = 0;
	return obj;
}

//反推 计算劳务所得
function fantuiloawu(salary) {
	var obj = {};
	salary = parseFloat(salary);
	if (salary <= 800){
		obj.yinageshui = 0.00;
		obj.shuiqian = salary;
		obj.shuihou = salary;
		return obj;
	}
		// return salary;
	var arr = [];
	arr.push((160 - salary) * 5 / 4 * -1); //>=800&&<4000
	arr.push(salary * 25 / 21); // >=4000&&<20000
	arr.push((2000 - salary) * 100 / 76 * -1); //20000<= && <50000
	arr.push((7000 - salary) * 100 / 68 * -1); //>=50000

	var res = [];
	for (var index in arr) {
		res.push(Math.abs(getLaowusuod(arr[index]).shuihou - salary));
	}
	var bufIndex = 0;
	var min = res[0];
	for (var index = 1; index < res.length; index++) {
		if (min > res[index]) {
			min = res[index];
			bufIndex = index;
		}
	}
	
	obj.yinageshui = arr[bufIndex] - salary;
	obj.shuiqian = arr[bufIndex];
	obj.shuihou = salary;
	return obj;
}

//=======年终奖计算 end===============
//获取税后工资
function jisuan1(salary, cityInfor) {
	salary = parseFloat(salary);

	//算出养老保险
	var yanglaojin = getYanglaoJin(cityInfor, salary);
	//获取医疗保险
	var yiliao = getYiliaobaoxian(cityInfor, salary);
	//获取失业保险
	var shiye = getShiyebaoxian(cityInfor, salary);
	//生育保险
	var shengyu = getShengyubaoxian(cityInfor, salary);
	//工伤保险
	var gongshang = getGongshangbaoxian(cityInfor, salary);
	//公积金
	var gongjijin = getGongjijin(cityInfor, salary);
	//个人保险缴费总额（五险一金）
	var sum = [];
	sum.push(yanglaojin);
	sum.push(yiliao);
	sum.push(shiye);
	sum.push(shengyu);
	sum.push(gongshang);
	sum.push(gongjijin);
	//个人缴纳
	var gerenshuie = getGerenshui(sum);

	//应纳税额
	var ynse = salary - gerenshuie;
	YINGNAGESHUI_TAX = ynse;
	//个人所交税费。公式2
	var gerenshuifei = getGerenShuiFei(ynse);
	//税后收入
	var shuihou = ynse - gerenshuifei;
	var taxTable = localStorage.getItem("SHULVTABLE");
	taxTable = JSON.parse(taxTable);
	var objbeau = {};
	if (salary <= parseFloat(taxTable.ignore)) {
		ynse = 0;
	}
	var objbeau = {};
	objbeau.ynse = gerenshuifei; //公式1
	objbeau.gerenshuie = gerenshuie; //五险一金
	objbeau.shuihou = shuihou; //税后收入
	return objbeau;
}
//获取税前工资
//salary:税后；grsds:个人缴纳
function jisuan2(salary, grsds, cityInfor) {
	if (cityInfor == null)
		return;
	salary = parseFloat(salary);
	grsds = parseFloat(grsds);

	var shulv = localStorage.getItem("SHULVTABLE");
	shulv = JSON.parse(shulv);
	var add = getGerenBuChong(cityInfor);
	var gescale = getGerenshuiSum(cityInfor);
	var result = [];

	var base = parseFloat(shulv.ignore);
	var add = getGerenBuChong(cityInfor);
	var list = shulv.table;
	for (var index in list) {
		var buf = (salary - base - parseFloat(list[index].susuan)) / (1 - parseFloat(list[index].point)) + base;
		result.push(buf + grsds);
	}
	result.push(salary + grsds);
	return Math.max.apply(null, result);
}
//获取全部保险上下限
//获取个人总补充
function getGerenBuChong(cityinfor) {
	var add = 0.0;
	add += parseFloat(isEmpty(cityinfor.yanglao.selfadd) ? 0 : cityinfor.yanglao.selfadd);
	add += parseFloat(isEmpty(cityinfor.yiliao.selfadd) ? 0 : cityinfor.yiliao.selfadd);
	add += parseFloat(isEmpty(cityinfor.shiye.selfadd) ? 0 : cityinfor.shiye.selfadd);
	add += parseFloat(isEmpty(cityinfor.shengyu.selfadd) ? 0 : cityinfor.shengyu.selfadd);
	add += parseFloat(isEmpty(cityinfor.gongshang.selfadd) ? 0 : cityinfor.gongshang.selfadd);
	add += parseFloat(isEmpty(cityinfor.gongjijin.selfadd) ? 0 : cityinfor.gongjijin.selfadd);
	return add;
}
//获取选中城市基数
function getCityInfor() {
	var citySession = sessionStorage.getItem("selecedCity_session");
	citySession = JSON.parse(citySession);
	if (isEmpty(citySession))
		return null;
	var cityinfor = sessionStorage.getItem("CURRENTCITY_INFOR");
	cityinfor = JSON.parse(cityinfor);
	if (isEmpty(cityinfor) || cityinfor.name != citySession.cityName) {
		var cityInfor = localStorage.getItem("CITY_JSON");
		cityInfor = JSON.parse(cityInfor).city;
		var count = 0;
		for (var index in cityInfor) {
			var bufObj = cityInfor[index].item;
			for (var ind in bufObj) {
				if (count == citySession.citynum) {
					sessionStorage.setItem("CURRENTCITY_INFOR", JSON.stringify(bufObj[ind]));
					return bufObj[ind];
				}
				count++;
			}
		}
	} else {
		return cityinfor;
	}
	// return bufObj[0];
}
//获取输入城市的个人税率总和
function getGerenshuiSum(cityinfor) {
	var tax = 0.0;
	tax += parseFloat(cityinfor.yanglao.selfscal);
	tax += parseFloat(cityinfor.yiliao.selfscal);
	tax += parseFloat(cityinfor.shiye.selfscal);
	tax += parseFloat(cityinfor.shengyu.selfscal);
	tax += parseFloat(cityinfor.gongshang.selfscal);
	tax += parseFloat(cityinfor.gongjijin.selfscal);
	return tax;
}
//计算养老金
function getYanglaoJin(orgindata, salary) {
	var obj = orgindata.yanglao;
	var based;
	if (salary <= parseFloat(obj.basedown)) {
		based = parseFloat(obj.basedown)
	} else if (salary >= parseFloat(obj.basetop)) {
		based = parseFloat(obj.basetop);
	} else {
		based = salary;
	}
	return {
		"compput": based * parseFloat(obj.compscale),
		"selfput": based * parseFloat(obj.selfscal)
	};
}
//获取医疗保险
function getYiliaobaoxian(orgindata, salary) {
	var obj = orgindata.yiliao;
	var based;
	if (salary <= parseFloat(obj.basedown)) {
		based = parseFloat(obj.basedown)
	} else if (salary >= parseFloat(obj.basetop)) {
		based = parseFloat(obj.basetop);
	} else {
		based = salary;
	}
	return {
		"compput": based * parseFloat(obj.compscale) + parseFloat(obj.compadd),
		"selfput": based * parseFloat(obj.selfscal) + parseFloat(obj.selfadd)
	};
}
//获取失业保险
function getShiyebaoxian(orgindata, salary) {
	var obj = orgindata.shiye;
	var based;
	if (salary <= parseFloat(obj.basedown)) {
		based = parseFloat(obj.basedown)
	} else if (salary >= parseFloat(obj.basetop)) {
		based = parseFloat(obj.basetop);
	} else {
		based = salary;
	}
	return {
		"compput": based * parseFloat(obj.compscale),
		"selfput": based * parseFloat(obj.selfscal)
	};
}
//计算生育保险
function getShengyubaoxian(orgindata, salary) {
	var obj = orgindata.shengyu;
	var based;
	if (salary <= parseFloat(obj.basedown)) {
		based = parseFloat(obj.basedown)
	} else if (salary >= parseFloat(obj.basetop)) {
		based = parseFloat(obj.basetop);
	} else {
		based = salary;
	}
	return {
		"compput": based * parseFloat(obj.compscale),
		"selfput": based * parseFloat(obj.selfscal)
	};
}
//工伤保险
function getGongshangbaoxian(orgindata, salary) {
	var obj = orgindata.gongshang;
	var based;
	if (salary <= parseFloat(obj.basedown)) {
		based = parseFloat(obj.basedown)
	} else if (salary >= parseFloat(obj.basetop)) {
		based = parseFloat(obj.basetop);
	} else {
		based = salary;
	}
	return {
		"compput": based * parseFloat(obj.compscale),
		"selfput": based * parseFloat(obj.selfscal)
	};
}
//公积金
function getGongjijin(orgindata, salary) {
	var obj = orgindata.gongjijin;
	var based;
	if (salary <= parseFloat(obj.basedown)) {
		based = parseFloat(obj.basedown)
	} else if (salary >= parseFloat(obj.basetop)) {
		based = parseFloat(obj.basetop);
	} else {
		based = salary;
	}
	return {
		"compput": based * parseFloat(obj.compscale),
		"selfput": based * parseFloat(obj.selfscal)
	};
}
//个人五险一金总交额
function getGerenshui(sum) {
	var contmoney = 0;
	for (var index in sum) {
		contmoney += parseFloat(sum[index].selfput);
	}
	return contmoney;
}

//个人税费
//yjse:应缴税额。公式2
function getGerenShuiFei(yjse) {
	var shuitable = localStorage.getItem("SHULVTABLE");
	shuitable = JSON.parse(shuitable);
	var list = shuitable.table;
	var base = parseFloat(shuitable.ignore);
	var result = [];
	for (var index in list) {
		result.push((yjse - base) * parseFloat(list[index].point) - parseFloat(list[index].susuan));
	}
	result.push(0);
	return Math.max.apply(null, result);
}

function getFunction(codeStr, yjse) {
	return "(function() {if" + codeStr.replace(/x/g, yjse + "") + " return true;return false;})()";
}

//获取当前选中城市的，基本上下限
function getCityBaseLineObj() {
	var cityInfor = getCityInfor();
	var arrTop = [];
	arrTop.push(cityInfor.yanglao.basetop);
	arrTop.push(cityInfor.yiliao.basetop);
	arrTop.push(cityInfor.shiye.basetop);
	arrTop.push(cityInfor.shengyu.basetop);
	arrTop.push(cityInfor.gongshang.basetop);
	arrTop.push(cityInfor.gongjijin.basetop);

	var arrDown = [];
	arrDown.push(cityInfor.yanglao.basedown);
	arrDown.push(cityInfor.yiliao.basedown);
	arrDown.push(cityInfor.shiye.basedown);
	arrDown.push(cityInfor.shengyu.basedown);
	arrDown.push(cityInfor.gongshang.basedown);
	arrDown.push(cityInfor.gongjijin.basedown);
	var result = {};
	result.topLimit = 0;
	result.downLimit = 0;
	result.cityname = cityInfor.name;
	var scalBuf = parseFloat(cityInfor.yanglao.selfscal);
	var selfAdd = isEmpty(cityInfor.yanglao.selfadd)?0:parseFloat(cityInfor.yanglao.selfadd);
	result.topLimit += parseFloat(cityInfor.yanglao.basetop) * scalBuf;
	result.downLimit += parseFloat(cityInfor.yanglao.basedown) * scalBuf;
	result.topLimit += selfAdd;
	result.downLimit += selfAdd;
	
	scalBuf = parseFloat(cityInfor.yiliao.selfscal);
	selfAdd = isEmpty(cityInfor.yiliao.selfadd)?0:parseFloat(cityInfor.yiliao.selfadd);
	result.topLimit += parseFloat(cityInfor.yiliao.basetop) * scalBuf;
	result.downLimit += parseFloat(cityInfor.yiliao.basedown) * scalBuf;	
	result.topLimit += selfAdd;
	result.downLimit += selfAdd;
	
	scalBuf = parseFloat(cityInfor.shiye.selfscal);
	selfAdd = isEmpty(cityInfor.shiye.selfadd)?0:parseFloat(cityInfor.shiye.selfadd);
	result.topLimit += parseFloat(cityInfor.shiye.basetop) * scalBuf;
	result.downLimit += parseFloat(cityInfor.shiye.basedown) * scalBuf;
	result.topLimit += selfAdd;
	result.downLimit += selfAdd;
	
	scalBuf = parseFloat(cityInfor.shengyu.selfscal);
	selfAdd = isEmpty(cityInfor.shengyu.selfadd)?0:parseFloat(cityInfor.shengyu.selfadd);
	result.topLimit += parseFloat(cityInfor.shengyu.basetop) * scalBuf;
	result.downLimit += parseFloat(cityInfor.shengyu.basedown) * scalBuf;
	result.topLimit += selfAdd;
	result.downLimit += selfAdd;
	
	scalBuf = parseFloat(cityInfor.gongshang.selfscal);
	selfAdd = isEmpty(cityInfor.gongshang.selfadd)?0:parseFloat(cityInfor.gongshang.selfadd);
	result.topLimit += parseFloat(cityInfor.gongshang.basetop) * scalBuf;
	result.downLimit += parseFloat(cityInfor.gongshang.basedown) * scalBuf;
	result.topLimit += selfAdd;
	result.downLimit += selfAdd;
	
	scalBuf = parseFloat(cityInfor.gongjijin.selfscal);
	selfAdd = isEmpty(cityInfor.gongjijin.selfadd)?0:parseFloat(cityInfor.gongjijin.selfadd);
	result.topLimit += parseFloat(cityInfor.gongjijin.basetop) * scalBuf;
	result.downLimit += parseFloat(cityInfor.gongjijin.basedown) * scalBuf;
	result.topLimit += selfAdd;
	result.downLimit += selfAdd;
	result.downLimit = result.downLimit.toFixed(2);
	result.topLimit = result.topLimit.toFixed(2);
	return result;
}

//控制输入的金额位数和小数位数
function getFilterNumber(num) {
	var value = clearNoNum(num);
	if (value > 99999999.0) //控制输入最大
	{
		value = value.toString().substring(0, 8); //超出截位
	}
	return value;
}


//检测输入规则
function clearNoNum(value) {
	value = value.replace(/[^\d.]/g, ""); //清除“数字”和“.”以外的字符   
	value = value.replace(/\.{2,}/g, "."); //只保留第一个. 清除多余的   
	value = value.replace(".", "$#$").replace(/\./g, "").replace("$#$", ".");
	value = value.replace(/^(\-)*(\d+)\.(\d\d).*$/, '$1$2.$3'); //只能输入两个小数   
	if (value.indexOf(".") < 0 && value != "") { //以上已经过滤，此处控制的是如果没有小数点，首位不能为类似于 01、02的金额  
		value = parseFloat(value);
	}
	return value;
}